/*
 * linux/include/asm-arm/proc-armv/segment.h
 *
 * Copyright (C) 1996 Russell King
 */

#ifndef __ASM_PROC_SEGMENT_H
#define __ASM_PROC_SEGMENT_H

extern void __put_word_unaligned(unsigned long x, void* y, int bUser);
extern unsigned long __get_word_unaligned(const void* y, int bUser);

static  __inline__ void __put_user(unsigned long x, void * y, int size)
{

	switch (size) {
	case 1:
	__asm__("
       teq	    %2, #0
       strnebt	%0, [%1]
       streqb	  %0, [%1]"
	: : "r" (x), "r" (y), "r" (current->tss.fs)
	: "cc");
	break;
	case 2:
	{ register unsigned long tmp1 = x; void *tmp2 = y;
	__asm__ __volatile__("
       teq	    %4, #0
       strnebt	%0, [%1], #1
       streqb	  %0, [%1], #1
       mov	    %0, %0, lsr #8
       strnebt	%0, [%1]
       streqb	  %0, [%1]"
	: "=&r" (tmp1), "=&r" (tmp2)
	: "0" (tmp1), "1" (tmp2), "r" (current->tss.fs)
	: "cc");
	}
	break;
	case 4:
	{
		unsigned long cur_task = (unsigned long) current->tss.fs;
		if ((int)y & 3)
			__put_word_unaligned(x, y, cur_task);
		else
			__asm__("
       teq	%2, #0
       strnet	%0, [%1]
       streq	%0, [%1]"
			: : "r" (x), "r" (y), "r" (cur_task)
			: "cc");
	}
	break;
	default:
//	bad_user_access_length ();
	}
}

static __inline__ unsigned long __get_user(const void *y, int size)
{
	unsigned long result;
	register unsigned long tmp1,tmp2;

	switch (size) {
	case 1:
	__asm__("
       teq	    %2, #0
       ldrnebt	%0, [%1]
       ldreqb	  %0, [%1]"
	: "=r" (result)
	: "r" (y), "r" (current->tss.fs)
	: "cc");
	return result;
	case 2:
	__asm__("
       teq     %4, #0      
       bne     1f      
       @user handler   
       mov     %1, %3  
       ldrb    %0, [%1], #1
       ldrb    %2, [%1], #1
       orr     %0, %0, %2, lsl #8
       b       2f          
1:                         
       @svc handler        
       mov     %1, %3      
       ldrbt   %0, [%1], #1
       ldrbt   %2, [%1], #1
       orr     %0, %0, %2, lsl #8
2:     "
	: "=&r" (result), "=&r" (tmp1), "=&r" (tmp2)
	: "r" (y), "r" (current->tss.fs)
	: "cc");
	return result;
	case 4:
	{
		unsigned long cur_task = (unsigned long) current->tss.fs;
		if ((int)y & 3)
			result = __get_word_unaligned(y, cur_task);
		else
			__asm__("
       teq	   %2, #0
       ldreq   %0, [%1]
       ldrnet  %0, [%1]"
	: "=&r" (result)
	: "r" (y), "r" (cur_task)
	: "cc");
	}
	return result;
	default:
//	return bad_user_access_length ();
	return(0);
	}
}		

#endif /* __ASM_PROC_SEGMENT_H */

